INSERT IGNORE INTO dicom.DICOMWorkList
(AccessionN, PatientID, PatientNam, PatientBir, PatientSex, StartDate, Modality, LastMenstr )
SELECT trc_dossier.code_trace_dossier, sig_interface.identifiant,
   CONCAT(glb_patient.nom, '^', glb_patient.prenom),
   DATE_FORMAT(glb_patient.date_naissance,'%Y%m%d') ,
   'F',
   DATE_FORMAT(trc_dossier.date_entree,'%Y%m%d'),
   'US',
   DATE_FORMAT(sa_grossesse.date_derniere_regle,'%Y%m%d')
FROM gyndata.trc_dossier
   INNER JOIN gyndata.glb_patient ON trc_dossier.code_patient = glb_patient.code_patient
   INNER JOIN gyndata.sig_interface ON glb_patient.code_patient = sig_interface.code_patient
   LEFT JOIN gyndata.sa_grossesse ON glb_patient.code_patient = sa_grossesse.code_patient
WHERE station IN ('STA_MAT_008','STA_MAT_027','STA_MAT_015','STA_MAT_033')
AND date_entree >=CURDATE() AND date_sortie IS NULL;
