/*
 * DicomFile.java - t@C̃I[vEt@C̐؂oEVR̉
 *
 * Copyright(C) 2000, Nagoya Institute of Technology, Iwata laboratory and Takahiro Katoji
 * http://mars.elcom.nitech.ac.jp/dicom/
 *
 * @author	Takahiro Katoji(mailto:katoco@mars.elcom.nitech.ac.jp)
 * @version
 *
 * mvh 20080826: Use din.read instead of din.skip: did not work on cgi-generated data
 * mvh 20080826: reset part 10 flags after exception
 *
 */

package dicomviewer;

import java.io.*;
import java.text.*;
import java.net.*;
import java.util.*;

public class DicomFile {

  int             debug_level = 3;

  boolean         isLtlEndian;      // littleEndian]\̂ƂAtrue
  boolean         vrType;           // IVȐꍇAtrue
  boolean         patientPrivacy;   // ҂̃vCoV[邽߁AҖϊƂtrue
  boolean         VReqSQ = false;   // V[PX؂荀ڂ̂߂̃tO
  boolean         containDic;       // DICOMɊ܂܂^OH
  boolean         dicomPart10;      // DICOMKipart10̂ƂA true
  boolean         Part10Endian;     // dicomPart10]\pflag
  boolean         Part10Endian2;
  boolean         Part10vr;         // dicomPart10vrpflag
  boolean         Part10vr2;
  boolean         Part10flag;     // dicomPart10pflag
  DicomDic        dicomDic;         // DICOM
  DicomData       dicomData;        // i[f[^̔


  // RXgN^
  public DicomFile(boolean argIsLtlEndian, boolean argVRType, boolean privacy, DicomDic argDicomDic) {
    patientPrivacy = privacy;
    isLtlEndian = Part10Endian = Part10Endian2 = argIsLtlEndian;
    vrType = Part10vr = Part10vr2 = argVRType;
    dicomDic = argDicomDic;
    dicomPart10 = Part10flag = false;
  }
  public DicomFile(boolean argIsLtlEndian, boolean argVRType, DicomDic argDicomDic) {
    this(argIsLtlEndian, argVRType, false, argDicomDic);
  }
  public DicomFile(DicomDic argDicomDic) {
    this(true, false, false, argDicomDic);
  }

  // DICOMt@C؂o
  public DicomData load(String imgURL){
    // f[^i[锠
    dicomData = new DicomData();

    try {

      URL urlConn;
      FileInputStream FinS;
      BufferedInputStream inS;
      DataInputStream din;

//      if(imgURL.matches("https*:\\p{ASCII}*")){
        System.out.println("http");
        // DICOMt@ChttpŃQbg邽߂URL
        urlConn = new URL(imgURL);
        // InputStream쐬B
        // xABufferedInputStream܂Ƃɂ荂B
        // InputStream inS = urlConn.openStream();
        inS = new BufferedInputStream(urlConn.openStream());
        din = new DataInputStream(inS);
        System.out.println("http");
//      }else{
//        System.out.println("file");
//        FinS = new FileInputStream(imgURL);
//        inS = new BufferedInputStream(FinS);
//        din = new DataInputStream(inS);
//        System.out.println("file");
//      }

      int tempInt;
      int part10sum = 0;
      int part10length = 0;
      byte[] buff2 = new byte[2];
      byte[] buff4 = new byte[4];

      String group;
      String number;
      String tag;
      String vr;
      int length;
      byte[] value;

      // t@CŌ܂œǂ
      while (din.read(buff2) != -1) {
        // ^O
        tempInt = readInt2(buff2);
        group  = Integer.toString((tempInt&0x0000f000)>>12,16);
        group += Integer.toString((tempInt&0x00000f00)>>8,16);
        group += Integer.toString((tempInt&0x000000f0)>>4,16);
        group += Integer.toString((tempInt&0x0000000f),16);
        din.readFully(buff2);
        tempInt = readInt2(buff2);
        number  = Integer.toString((tempInt&0x0000f000)>>12,16);
        number += Integer.toString((tempInt&0x00000f00)>>8,16);
        number += Integer.toString((tempInt&0x000000f0)>>4,16);
        number += Integer.toString((tempInt&0x0000000f),16);
        tag = ("("+group+","+number+")");

        // fobOp
        if (debug_level > 3) System.out.println("currentTag is : " + tag);
        dicomData.setTag(tag);  // DicomDataɃZbg

        // DICOMɊ܂܂Ă邩ǂH
        containDic = dicomDic.isContain(tag);

        if(vrType && !VReqSQ){
          // t@CIVȐꍇ
          StringBuffer sbuff = new StringBuffer(2);
          din.readFully(buff2);
          for(int i=0; i<2; i++)
	          sbuff.append((char)buff2[i]);
          dicomData.setVR(tag, sbuff.toString());

          // VRɂāAlςB
          if(sbuff.toString().equals("OB") ||
             sbuff.toString().equals("OW") ||
             sbuff.toString().equals("SQ")) {
            // VROBAOWA܂SQ̏ꍇ
            din.read(buff2);
            // l(4bytesǂݍVersion)
            din.readFully(buff4);
            length = readInt4(buff4);
            //DicomPart10p擾
            if (Part10flag) part10sum += 4;
          } else {
            // VROBAOWA܂SQȊO
	    // l(2bytesǂݍVersion)
            din.readFully(buff2);
            length = readInt2(buff2);
          }
        } else{
      	  // t@CÖٓIVȐꍇ
	  // VRDICOMɂăQbgB
	  // l(4bytesǂݍVersion)
          if(containDic) dicomData.setVR(tag, dicomDic.getVR(tag));
          else dicomData.setVR(tag, "na");
          din.readFully(buff4);
          length = readInt4(buff4);
        }

        // V[PX؂荀ڂAtOς
        if(tag.equals("(fffe,e0dd)")) VReqSQ = false;

        vr = dicomData.getVR(tag);
        // fobOp
        if (debug_level > 3) System.out.println("currentVR is : " + vr);
        if (debug_level > 3) System.out.println("currentLength: " + length);

        //vf`̏ꍇ
        if(length == -1) {
          VReqSQ = true;
          length = 0;
          if(tag.equals("(fffe,e000)")) VReqSQ = false;
        }

        // l
        value = new byte[length];
        din.readFully(value);
        dicomData.setValue(tag, value);

        // f[^̎擾
        if(containDic) {
          dicomData.setName(tag, dicomDic.getName(tag));
          dicomData.setVM(tag, dicomDic.getVM(tag));
          dicomData.setVersion(tag, dicomDic.getVersion(tag));
        }else {
          dicomData.setName(tag, "NotContainedInDICOMDictionary");
          dicomData.setVM(tag, "na");
          dicomData.setVersion(tag, "na");
        }

        // fobOp
        if (debug_level > 3) System.out.println("currentName is : " + dicomData.getName(tag));

        this.analyzer(tag, vr);

        //DicomPart10p
        if(Part10flag){
          if(tag.equals("(0002,0000)")){
            part10length = Integer.parseInt(dicomData.getAnalyzedValue(tag));
          }else{
            part10sum += length;
            part10sum += 8;
            if(part10length == part10sum){
              isLtlEndian = Part10Endian;
              vrType = Part10vr;
              Part10flag = false;
              part10length = 0;
              part10sum = 0;
            }
          }
          //DicomPart10A]\
          if(tag.equals("(0002,0010)")){
            String TransferSyntax = dicomData.getAnalyzedValue(tag);
            if(TransferSyntax.matches("1.2.840.10008.1.2\\p{ASCII}??")){
              if (debug_level > 3) System.out.println("Implicit VR Little Endian");
              Part10Endian = true;
              Part10vr = false;
            }else if(TransferSyntax.matches("1.2.840.10008.1.2.2\\p{ASCII}??")){
              if (debug_level > 3) System.out.println("Explicit VR Big Endian");
              Part10Endian = false;
              Part10vr = true;
            }else{
              if (debug_level > 3) System.out.println("Explicit VR Big Endian:");
              Part10Endian = true;
              Part10vr = true;
            }
          }
            
        }
        if(!dicomPart10 && tag.equals("(0000,0000)") && length == 0){
          //vtBNXǂݔ΂A0002^O̎IVRLtlEndianɂ
          byte[] buff124 = new byte[124];
            din.read(buff124);      //128+41ǂݍ񂾕
          if (debug_level > 3) System.out.println("skip");
          isLtlEndian = true;
          vrType = true;
          dicomPart10 = Part10flag = true;
          if (debug_level > 3) System.out.println("part10 ");
        }
        //lo
        if (debug_level > 5){
          StringBuffer buffer=new StringBuffer();
          for(int i=0; i<dicomData.getValue(tag).length; i++){
            String tmp=Integer.toHexString(dicomData.getValue(tag)[i] & 0xff);
            if(tmp.length()==1){buffer.append('0').append(tmp);
            }else{
              buffer.append(tmp);
            }
          }
          System.out.println("Value = " + buffer);
        }
        
        
      } // while ܂ŁB

      //DicomPart10pflag
      if(dicomPart10){
        Part10flag = dicomPart10 = false;
        isLtlEndian = Part10Endian2;
        vrType = Part10vr2;
      }
      
      din.close();
      inS.close();
    }
    catch(EOFException eof){
      System.out.println("DicomFile.EOFException: " + eof.getMessage() );
    }
    catch(IOException ioe){
      System.out.println("DicomFile.IOException: " + ioe.getMessage() );
    }
    catch(Exception e){
      System.out.println("DicomFile.Exception: " + e.getMessage() );
    }
    
    if(dicomPart10){
      Part10flag = dicomPart10 = false;
      System.out.println("here");
      isLtlEndian = Part10Endian2;
      vrType = Part10vr2;
    }

    // vCoV[΍̃R[h
    // (0010,0010)̃f[^
    //     Takahiro Katoji -> T*k*h*r* *a*o*i
    // ̂悤ȁu*v̕ɕϊ
    if(patientPrivacy) {
      String patientName;
      // DicomDataɃZbgĂ銳Җ擾
      patientName = dicomData.getAnalyzedValue("(0010,0010)");
      StringBuffer patientBuf = new StringBuffer(patientName);
      
      // Җ̊Ԗڂ̕u*vɕϊ
      for(int i=0; i < patientName.length(); i++) {
        if(i % 2 == 1) patientBuf.setCharAt(i, '*');
      }
      
      // ϊ̕DicomDataɖ߂
      dicomData.setAnalyzedValue("(0010,0010)", patientBuf.toString());
    }
    
    // DicomDataԂďI
    return dicomData;
  }

  // 2bytesǂIntɕϊ
  private int readInt2(byte[] argtmp){
    int tmp;
    if(isLtlEndian) {
      tmp = ((0x000000ff & argtmp[1]) << 8 | (0x000000ff & argtmp[0]));
    } else {
      tmp = ((0x000000ff & argtmp[0]) << 8 | (0x000000ff & argtmp[1]));
    }
    return tmp;
  }

  // 4bytesǂIntɕϊ
  private int readInt4(byte[] argtmp){
    int tmp;
    if(isLtlEndian) {
      tmp = ((0x000000ff & argtmp[3]) << 24 | (0x000000ff & argtmp[2]) << 16
           | (0x000000ff & argtmp[1]) << 8  | (0x000000ff & argtmp[0]));
    } else {
      tmp = ((0x000000ff & argtmp[0]) << 24 | (0x000000ff & argtmp[1]) << 16
           | (0x000000ff & argtmp[2]) << 8  | (0x000000ff & argtmp[3]));
    }
    return tmp;
  }

  // VR͂f[^vf̒lK؂ȏɕϊB
  private void analyzer(String currentTag, String currentVR) {
	
    if(currentVR==null){
      // VRꍇ
      dicomData.setAnalyzedValue(currentTag, "Not contain VR.");
    }
    else if(dicomData.getValueLength(currentTag)==0){
      // 傫0͖
      dicomData.setAnalyzedValue(currentTag, "");
    }
    else if(currentVR.equals("PN") | currentVR.equals("LO")
          |	currentVR.equals("SH") | currentVR.equals("LT")
          |	currentVR.equals("ST") | currentVR.equals("UI")
          |	currentVR.equals("DS") | currentVR.equals("CS")
          |	currentVR.equals("IS") | currentVR.equals("AS")){
      // ʂ̕
      for(int j=0; j<dicomData.getValueLength(currentTag); j++)
        if((dicomData.getValue(currentTag))[j] == 0)
           (dicomData.getValue(currentTag))[j] = 20;
      dicomData.setAnalyzedValue(currentTag, new String(dicomData.getValue(currentTag)));

    }
    else if(currentVR.equals("SS")){
      int tmp;
      // 16bitt2i
      if(isLtlEndian){
        tmp = (((int)(dicomData.getValue(currentTag))[1] & 0x000000ff) << 8)
             | ((int)(dicomData.getValue(currentTag))[0] & 0x000000ff);
      } else {
        tmp = (((int)(dicomData.getValue(currentTag))[0] & 0x000000ff) << 8)
             | ((int)(dicomData.getValue(currentTag))[1] & 0x000000ff);
      }
      if((tmp & 0x00008000)==0x00008000) 	// 
				  tmp |= 0xffff0000;
      dicomData.setAnalyzedValue(currentTag, Integer.toString(tmp));

    }
    else if(currentVR.equals("US")){
      int tmp;
      // 16bit2i
      if(isLtlEndian){
        tmp = (((int)(dicomData.getValue(currentTag))[1] & 0x000000ff) << 8)
             | ((int)(dicomData.getValue(currentTag))[0] & 0x000000ff);
      } else {
        tmp = (((int)(dicomData.getValue(currentTag))[0] & 0x000000ff) << 8)
             | ((int)(dicomData.getValue(currentTag))[1] & 0x000000ff);
      }
      dicomData.setAnalyzedValue(currentTag, Integer.toString(tmp));
    }
    else if(currentVR.equals("UL")){
      int tmp;
      // 32bit2i
      if (isLtlEndian){
        tmp = (((int)(dicomData.getValue(currentTag))[3] & 0x000000ff) << 24)
            | (((int)(dicomData.getValue(currentTag))[2] & 0x000000ff) << 16)
            | (((int)(dicomData.getValue(currentTag))[1] & 0x000000ff) <<  8)
            |  ((int)(dicomData.getValue(currentTag))[0] & 0x000000ff);
      } else {
        tmp = (((int)(dicomData.getValue(currentTag))[0] & 0x000000ff) << 24)
            | (((int)(dicomData.getValue(currentTag))[1] & 0x000000ff) << 16)
            | (((int)(dicomData.getValue(currentTag))[2] & 0x000000ff) <<  8)
            |  ((int)(dicomData.getValue(currentTag))[3] & 0x000000ff);
      }
      dicomData.setAnalyzedValue(currentTag, Integer.toString(tmp));

    }
    else if(currentVR.equals("TM")){
      //  hh:mm:ss.frac
      dicomData.setAnalyzedValue(currentTag, new String(dicomData.getValue(currentTag)));
      StringBuffer buffer = new StringBuffer(dicomData.getAnalyzedValue(currentTag));
      buffer.insert(2, ":");
      buffer.insert(5, ":");
      dicomData.setAnalyzedValue(currentTag, buffer.toString());
    }
    else if(currentVR.equals("DA")){
      // t yyyy.mm.dd
      dicomData.setAnalyzedValue(currentTag, new String(dicomData.getValue(currentTag)));

      // 8bytesȂƂ,u-vǉ
      if(dicomData.getValueLength(currentTag)==8){
        StringBuffer buffer = new StringBuffer(dicomData.getAnalyzedValue(currentTag));
        buffer.insert(4, "-");
        buffer.insert(7, "-");
        dicomData.setAnalyzedValue(currentTag, buffer.toString());
      }else if(dicomData.getValueLength(currentTag) == 10){
        // 10byteŝƂ,u.vu-vɕύX
        StringTokenizer st = new StringTokenizer(dicomData.getAnalyzedValue(currentTag), ".");
        String temp  = st.nextToken();
        temp += "-" + st.nextToken();
        temp += "-" + st.nextToken();
        dicomData.setAnalyzedValue(currentTag, temp);
      }
    }
    else
      // T|[gĂȂ^O
      dicomData.setAnalyzedValue(currentTag, "Unknown VR");
    // fobOp
    if (debug_level > 3) System.out.println("AnalyzedValue :" + dicomData.getAnalyzedValue(currentTag));
  }
}


